import processing.core.*; import processing.opengl.*; import hypermedia.net.*; import processing.serial.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class WindEarth_GUI extends PApplet {//////////////////////////////////////
//           Wind Earth             //
//                                  //
//        by Pascal Chirol,         //
//  www.pascalchirol.easydesign.fr  //
//////////////////////////////////////


//import moviemaker.*;

/////////////////////////////////////////////////////////////////////////////////////
boolean serialOn = false;
Serial port;
UDP udp;
UDP_Conector conector;
GUI gui;
//MovieMaker mm;
History history;
///////////////////////////////////
String[] metarList;
int nbMetar = 3978;
String[] dataFaild = new String [200];
int numFailed = 0;
Metar[]metar = new Metar[nbMetar];
int nblife = 0;
int nblife2 = 0;
int nblife3 = 0;
Draws[]life = new Draws[20];
Draws[]life2 = new Draws[20];
Draws[]life3 = new Draws[20];
//////
String request = "";
int nbrequest = 0;
int maxrequest = 200;
String [] requestList = new String [maxrequest];
String statut = "";
int countKey = 0;
boolean winddraws = false;
boolean waitingForTheSun = false;
boolean auto = true;
float facteurTaille = 3;
float love = 1;
int curentWind = 0;
int count = 0;
int refeshFanStation = 0;
String station = "";
String[] info;
boolean option = true;
boolean fan_option = true;
int nbFan = 15;
Fan[]fan = new Fan[nbFan];
String nameSerial;
float vitesse,orientation;
///////////////
float depMapX = 0;
float depMapY = 0;
//////////////
PFont fontL;
PFont fontLB;
PFont fontC;
//////////////
int nbloader = 0;
boolean isLoading = true;
/////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
///////////////////////////////////////
public static void main( String args[] ) {
  PApplet.main( new String[] { 
    "--present", "WindEarth_GUI"                        } 
  );
} 

//////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
public void setup(){
  //////////
  size(screen.width,screen.height,OPENGL);
  facteurTaille = ((screen.width)/1000)*3;
  //frameRate(200);
  smooth();
  background(0);
  //////////////////////////////
  conector = new UDP_Conector();
  history = new History();
  gui = new GUI();
  udp = new UDP(this, 6000);
  udp.log( true );
  udp.listen(true);
  port = new Serial(this, Serial.list()[0], 19200);
  println(Serial.list());
  nameSerial = (Serial.list()[0]);
  //mm = new MovieMaker(this,width,height,"movie.mov", MovieMaker.CINEPAK, MovieMaker.HIGH,10);
  fontL = loadFont("LevenimMT-48.vlw");
  fontLB = loadFont("LevenimMTBold-48.vlw");
  fontC = loadFont("CourierNewPS-BoldMT-48.vlw");
  ////////////////////////////
  ///////////////////
  metarList = loadStrings("True_Metar.txt");
  ///////////////////
  if(isLoading == false){
    println("Beginning to Create Object Class && reading METAR Data into class");
    for (int i = 0; i < nbMetar ; i++){
      try{
        String[] data;
        data = loadStrings("metar/"+metarList[i]+".txt");//PC
        //data = loadStrings("/metar/"+metarList[i]+".txt");//MAC
        metar[i] = new Metar(data, metarList[i],i);
      }
      catch(Exception x){
        println(""+x);
      }
    }
    udp.send("alive?", "localhost", 7000);
    int i = PApplet.parseInt(random(metarList.length));
    udp.send(str(i), "localhost", 7000);
  }
  ///////////////////////////////
  for(int i=0 ; i<nbFan ; i++){
    fan[i] = new Fan(i);
  }
}
/////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
public void draw(){
  background(0);
  /////////////////////////
  if(isLoading == true){
    count+=10;
    //////// Loading Animation....
    try{
      if (nbloader < nbMetar){
        String[] data;
        data = loadStrings("metar/"+metarList[nbloader]+".txt");//PC
        //data = loadStrings("/metar/"+metarList[nbloader]+".txt");//MAC
        metar[nbloader] = new Metar(data, metarList[nbloader],nbloader);
        nbloader++;
      }
      else{
        udp.send( "alive?", "localhost", 7000 );
        int i = PApplet.parseInt(random(metarList.length));
        udp.send(str(i), "localhost", 7000);
        count = 0;
        isLoading = false;
      }
      ///////////////////////////
      textFont(fontLB, 30);
      fill(255);
      text("Wind Earth",gui.posX,gui.posY);
      textFont(fontLB, 12);
      fill(count);
      text("Please Wait :",gui.posX,gui.posY+20);
      fill(255);
      text("Loading Meteorological Station  : "+nbloader+" / "+nbMetar,gui.posX+80,gui.posY+20);
      if(count>255)count=0;
      ///////////////////
      for (int i = 0; i < nbloader ; i++){
        metar[i].draw();
      }
    }    
    catch(Exception x){
      println(""+x);
    }
  }
  /////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////
  if(isLoading == false){
    count++;
    mouseDep();
    ////////////////////////
    for (int i = 0; i < nbMetar ; i++){
      metar[i].draw();
    }
    try{
      gui.serialColor = color (255);
      //////////////////////////////////////
      for(int i=0 ; i<nbFan ; i++){
        fan[i].serialSend();
      }
      gui.draw();
      if(winddraws){
        for(int i=0;i<nblife;i++){
          life[i].draw();
        }
        for(int i=0;i<nblife2;i++){
          life2[i].draw();
        }
        for(int i=0;i<nblife3;i++){
          life3[i].draw();
        }
      }
      /////////////////////////////////
      //loadPixels();
      //mm.addFrame(pixels,width,height);
      //println("I RecVideo");
    }  
    catch(Exception x){
    }
    conector.alive();
  }
  ///////////////////
}
///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////
public void receive( byte[] data, String ip, int port ){
  conector.receive(data,ip,port);
}
//////////////////////////////////////////////////////////////////////////////
public void keyPressed() {
  ///////////////////////////////////////////////////////////
  gui.time = 0;
  statut = "> METAR Code : CAPS letters or Numbers are need";
  if(countKey == 0){
    request = "";
  }
  //////////////////////////////////////////////////////////
  if(keyCode == 27){
    udp.send("exit", "localhost", 7000);
  }
  if(keyCode == 32){
    statut = "> Up/Down = Zoom  ;  Space = Reset";
    facteurTaille = 3;
    depMapX = 0;
    depMapY = 0;
  }
  if(keyCode == UP){
    statut = "> Up/Down = Zoom  ;  Space = Reset";
    if(facteurTaille < 100){
      facteurTaille += 0.1f;
    }
  }
  if(keyCode == DOWN){ 
    statut = "> Up/Down = Zoom  ;  Space = Reset";
    if(facteurTaille > 0.1f){
      facteurTaille -= 0.1f;
    }
  }
  if(facteurTaille < 3){
    depMapX = 0;
    depMapY = 0;
  }
  if(keyCode == RIGHT){
    statut = "> Up/Down = Zoom  ;  Space = Reset; ";
    if(facteurTaille > 3) depMapX -= facteurTaille;
  }
  if(keyCode == LEFT){
    statut = "> Up/Down = Zoom  ;  Space = Reset; ";
    if(facteurTaille > 3) depMapX += facteurTaille;
  }
  if((keyCode == 8) || (keyCode == 127)){
    countKey=0;
    request = "";
  }
  if(PApplet.parseInt(key) > 64 && PApplet.parseInt(key) < 91){
    countKey++;
    request += key;
  }
  if(PApplet.parseInt(key) > 47 && PApplet.parseInt(key) < 58){
    countKey++;
    request += key;
  }
  ////////////////////////////////////////////////////////////////////////////
  if(countKey > 3){
    statut = "> "+nbMetar+" is false code or number > ";
    int temp = PApplet.parseInt(request);
    if((temp != 0) && (temp < 3978)){
      udp.send(request, "localhost", 7000 );
      println("NetWork Request for "+temp);
      statut = "> NetWork Request for  : "+(temp)+" = "+metar[PApplet.parseInt(temp)].myName;
    }
    else{
      for(int i=0; i<metarList.length;i++){
        if(request.equals(metarList[i])){
          udp.send(str(i), "localhost", 7000 );
          println("NetWork Request for : "+request);
          statut = "> NetWork Request for  : "+(request)+" = "+i;
        }
      }
    }
    countKey = 0;
    ///////////////////////////////////////////////////
  }
}
///////////////////////////////////////////////////////////////////////////////
public void dataFailded(String name){
  numFailed++;
  dataFaild[numFailed] = name;
  saveStrings("data/dataFaild.txt", dataFaild);
}
///////////////////////////////////////////////////////
public void mouseDep(){
  if(facteurTaille >3){
    if(mouseX<width/10)depMapX += (facteurTaille/constrain(mouseX,10,200))*10;
    if(mouseX>width-(width/10))depMapX -= (facteurTaille/constrain(width-mouseX,10,200))*10;
    if(mouseY<height/10)depMapY += (facteurTaille/constrain(mouseY,10,200))*10;
    if(mouseY>height-(height/20))depMapY -= (facteurTaille/constrain(height-mouseY,10,200))*10;
  }
}
///////////////////////////////////////////////////////////
public void mousePressed() {
  if((mouseX > 10) && (mouseX < 20) && (mouseY > 10) && (mouseY < 20)){
    udp.send("exit", "localhost", 7000);
    exit();
  }
  if((mouseX > gui.posX) && (mouseX < gui.posX+170) && (mouseY > gui.posY) && (mouseY < gui.posY+25)) {
    auto =! auto;
    if(auto){
      int i = PApplet.parseInt(random(metarList.length));
      udp.send(str(i), "localhost", 7000);
    }
  }
  if((mouseX > gui.posX+185) && (mouseX < gui.posX+280) && (mouseY > gui.posY+5) && (mouseY < gui.posY+25)) {
    winddraws =! winddraws;
  }
  if((mouseX > gui.posX+305) && (mouseX < gui.posX+405) && (mouseY > gui.posY) && (mouseY < gui.posY+25)) {
    //gui.fan_gui =! gui.fan_gui;
  }
  if(winddraws){
    if((mouseX > gui.posX+185) && (mouseX < gui.posX+195) && (mouseY > gui.posY-5) && (mouseY < gui.posY+5)) {
      if(mouseButton == RIGHT){
        for(int i = 0;i<nblife;i++){
          life[i] = null;
        }
        nblife=0;
      }
      if(mouseButton == LEFT){
        if(nblife<20){
          life[nblife] = new Draws(0);
          nblife++;
        }
      }
    }
    /////////////////////////////
    if((mouseX > gui.posX+185) && (mouseX < gui.posX+195) && (mouseY > gui.posY-20) && (mouseY < gui.posY-10)) {
      if(mouseButton == RIGHT){
        for(int i = 0;i<nblife2;i++){
          life2[i] = null;
        }
        nblife2=0;
      }
      if(mouseButton == LEFT){
        if(nblife2<20){
          life2[nblife2] = new Draws(1);
          nblife2++;
        }
      }
    }
    /////////////////////////////
    if((mouseX > gui.posX+185) && (mouseX < gui.posX+195) && (mouseY > gui.posY-35) && (mouseY < gui.posY-25)) {
      if(mouseButton == RIGHT){
        for(int i = 0;i<nblife3;i++){
          life3[i] = null;
        }
        nblife3=0;
      }
      if(mouseButton == LEFT){
        if(nblife3<20){
          life3[nblife3] = new Draws(2);
          nblife3++;
        }
      }
    }
  }
  ///////////////////////
  if((mouseX > width-225) && (mouseX < width-225+200) && (mouseY > fan[0].y+55) && (mouseY < fan[0].y+85)) {
    love = PApplet.parseFloat((mouseX-(width-225))/20);
  }
  if(gui.fan_gui){
    if((mouseX > fan[0].x) && (mouseX < fan[0].x+50) && (mouseY > fan[0].y+55) && (mouseY < fan[0].y+85)) {
      gui.mode =! gui.mode;
      if(gui.mode){
        gui.fanModeColor = color(255);
      }
      else{
        gui.fanModeColor = color(0);  
      }
    }
    if((mouseX > fan[0].x+105) && (mouseX < fan[0].x+155) && (mouseY > fan[0].y+55) && (mouseY < fan[0].y+85)) {
      serialOn =! serialOn;
      println(Serial.list());
      if(serialOn == true){
        for(int i=0 ; i<nbFan ; i++){
          fan[i].tempPower = 0;
        }
      }
      if(serialOn == false){
        port.write(200); // reset value external PIC
      }
    }
  }
  ///////////////////
}

class Draws{
  float x,y,px,py,depx,depy,loto,tempOrientation;
  int nbtrace = 500;
  float [] x2 = new float[nbtrace];
  float [] y2 = new float[nbtrace];
  int coul = color(255);
  int coul2 = color(255);
  boolean negX = false;
  boolean negY = false;
  float time = 0;
  int mode = 0;
  //////////////////////////
  Draws(int type){
    mode = type;
    x = width/2;
    y = height/2;
    px = x;
    py = y;
    depx = 0.1f;
    depy = 0.1f;
    //vitesse = 0;
    //orientation = 0;
    tempOrientation = 0;
    for(int i=0;i<nbtrace;i++){
      x2[i] = x;
      y2[i] = y;
    }
  }
  ////////////////////////////
  public void draw(){
    try{
      if(mode==0)style0();
      if(mode==1)style1();
      if(mode==2)style2();
    }  
    catch(Exception x){
    } 
  }
  ///////////////////////////////////////////////////
  public void style0(){
    time = (radians(orientation-90));
    x += (cos(time))*vitesse;
    y += (sin(time))*vitesse;
    ///////////////////////////
    verif();
    tracer();
    fill(255);
    ellipse(x,y,5,5);
  }
  ////////////////////////////////////////////////////
  public void style1(){
    if(PApplet.parseInt (tempOrientation) != PApplet.parseInt (orientation)){
      tempOrientation += (orientation-tempOrientation)/10;
      if(tempOrientation > 360) tempOrientation = 0;
      if(tempOrientation < 0) tempOrientation = 360;
      time = (radians(tempOrientation-90));
    }
    else{
      time = (radians(tempOrientation-90));
    }
    x += (cos(time))*vitesse;
    y += (sin(time))*vitesse;
    ///////////////////////////
    verif();
    tracer();
    fill(255);
    ellipse(x,y,5,5);
  }
  ///////////////////////////////////////////////////
  public void tracer(){
    for(int i=(nbtrace-1);i>0;i--){
      x2[i] = x2[i-1];
      y2[i] = y2[i-1];
    }
    x2[0] = x;
    y2[0] = y;
    ///////////////////
    for(int i=0 ; i<(nbtrace-1) ; i++){
      noStroke();
      fill(255,255-(i/2));
      rect(x2[i],y2[i],1,1);
    }
  }
  ////////////////////////////////////////////////////
  public void style2(){
    time += (radians(orientation-90))/100;
    x += (cos(time))*vitesse;
    y += (sin(time))*vitesse;
    ///////////////////////////
    verif();
    tracer();
    fill(255);
    ellipse(x,y,5,5);
  }
  ///////////////////////////////////////////////////////
  public void verif(){
    if(x<0){
      x=width;
    }
    if(y<0){
      y=height;
    }
    if(x>width){
      x=0;
    }
    if(y>height){
      y=0;
    }
  }
}

class Fan{
  PFont fontL;
  int power = 0;
  int x,y;
  int num;
  int tempPower = power;
  int multiplik = 1;
  String name = "";
  /////////////////////////////////////////
  Fan(int i){
    fontL = loadFont("LevenimMTBold-48.vlw");
    num = i+1;
    x = width-450+(30*i);
    y = height-120;
    ///////////////
    if((num == 1) || (num == 3) || (num == 4) || (num == 6) || (num == 8) || (num == 9) || (num == 11) || (num == 13) || (num == 15)){
      multiplik = 5;
    }
    ///////////////
    serialSend();
  }
  //////////////////////////////////////////
  public void draw(){
    anti();
    ///////////////////
    noFill();
    stroke(255);
    ellipse(x+5,y-5-power*5,8,8);
    noSmooth();
    line(x+5,y-power*5,x+5,y);
    ////////////////
    for (int u=0;u<25;u++){
      noStroke();
      fill(0+(u*10));
      rect(x+5,y+25-u,1,1);
    }
    smooth();
    //////////////
    fill(255);
    textFont(fontL, 12);
    text(power,x,y+50);
    if(multiplik != 1) text("*",x+15,y+50);
    //////////////
    if(name != null){
      pushMatrix();
      translate(x+7, y-(power*5)-20);
      rotate(radians(-90));
      textFont(fontC, 12);
      text(name,0,0);
      popMatrix(); 
    }
  }
  //////////////////////////////////////////
  ///////////////////////////////////////////
  public void serialSend(){
    if(serialOn){
      if(power != tempPower){
        anti();
        gui.serialColor = color (0,200,40);
        port.write(255);
        port.write(num);
        port.write((power*multiplik));
        println("Fan : "+num+" = "+power*PApplet.parseInt(love)*multiplik);
        /////////////////
        tempPower = power;
      }
    }
  }
  ////////////////////////////////////////
  public void anti(){
    // ventilo special
    if(power <= 0) power = 0;
    if(power >= 100) power = 100;
  }
}

class GUI{
  int posX, posY;
  boolean fan_gui = false;
  boolean info_gui = true;
  boolean mode = false;
  int couleur = color(0,0,0);// netwok color
  int serialColor = color(0,0,0);
  int fanModeColor = color(0,0,0);
  float time = 300;
  ////////////////////////////////////
  GUI(){
    posX = 20;
    posY = height-200;
  }
  //////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void draw(){
    exit_gui();
    info();
    /////////////////////////////////
    if(mouseY > height-300){
      titre();
      request();
      separateur();
      network();
      wind();
      //fanC();
      /////////////////
      if(fan_gui){
        serialGUI();
        for(int i=0 ; i<nbFan ; i++){
          fan[i].draw();
        }
      }
    }
  }
  //////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void info(){
    if(info != null){
      for (int t=0; t<info.length-2;t++){
        fill(255);
        textFont(fontC, 14);
        text(info[t],posX,posY+50+(14*t));
      }
    }
  }
  //////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void titre(){
    textFont(fontLB, 30);
    fill(255);
    if(winddraws){
      text("Wind Draws",posX,posY);
    }
    else{
      text("Wind Earth",posX,posY);
    }

  }
  /////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void request(){
    time += 10;
    if(time<255){
      if(countKey == 0){
        fill(255,255-time);
        textFont(fontLB, 12);
        text(statut,posX,posY-40);
      }
      else{
        fill(255,255-time);
        stroke(255,255-time);
        textFont(fontL, 20);
        text("'"+request+"'",posX,posY-40);
        noSmooth();
        line(posX,posY-35,(abs(countKey)*14)+posX,posY-35);
        smooth();
        textFont(fontLB, 12);
        text(statut,posX+80,posY-40);
      }
    }
  }
  /////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void separateur(){
    fill(255);
    textFont(fontLB, 12);
    text("/",posX+170,posY+20);
    //text("/",posX+290,posY+20);
  }
  //////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void network(){
    stroke(255);
    fill(couleur);
    if(count<100)fill(255);
    if(auto == false)fill(0);
    ellipseMode(CENTER);
    ellipse(posX+5,posY+16,8,8);
    fill(255);
    textFont(fontLB, 12);
    if(auto){
      text("NetWork Auto Refresh",posX+15,posY+20);
    }
    else{
      text("NetWork Manual Refresh",posX+15,posY+20);
    }
  }
  //////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void wind(){
    fill(0);
    if(winddraws)fill(255);
    ellipse(posX+190,posY+16,8,8);
    fill(255);
    textFont(fontLB, 12);
    text("Wind Draws",posX+200,posY+20);
    ////////////////////////////////////////
    if(winddraws){
      if(nblife != 0){
        fill(255);
        noStroke();
        ellipse(posX+190,posY,8,8);
      }
      else{
        stroke(255);
        fill(0);
        ellipse(posX+190,posY,8,8);
      }
      /////////bouton 2
      if(nblife2 != 0){
        fill(255);
        noStroke();
        ellipse(posX+190,posY-15,8,8);
      }
      else{
        stroke(255);
        fill(0);
        ellipse(posX+190,posY-15,8,8);
      }
      /////////bouton 3
      if(nblife3 != 0){
        fill(255);
        noStroke();
        ellipse(posX+190,posY-30,8,8);
      }
      else{
        stroke(255);
        fill(0);
        ellipse(posX+190,posY-30,8,8);
      }
    }
  }
  //////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void fanC(){
    fill(0);
    stroke(255);
    if(fan_gui)fill(255);
    ellipse(posX+310,posY+16,8,8);
    fill(255);
    textFont(fontLB, 12);
    text("Fan controler",posX+320,posY+20);
  }
  //////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void serialGUI(){
    fill(fanModeColor);
    textFont(fontLB, 12);
    stroke(255);
    ellipse(fan[0].x+5,fan[0].y+71,8,8);
    fill(255);
    text("Fan Mode",fan[0].x+20,fan[0].y+75);
    ///////////////////////////////////////
    fill(0);
    if(serialOn)fill(serialColor);
    ellipse(fan[0].x+110,fan[0].y+71,8,8);
    fill(255);
    textFont(fontLB, 10);
    text(nameSerial,fan[0].x+125,fan[0].y+75);
    //textFont(fontC, 10);
    //text(nameSerial,fan[0].x+125,fan[0].y+90);
    /////////////////////////// bar de power
    textFont(fontLB, 14);
    text("*",width-235,fan[0].y+75);
    noFill();
    stroke(255);
    rect(width-225,fan[0].y+65,200,10);
    //
    fill(255,100);
    noStroke();
    rect(width-225,fan[0].y+65,(love*20)+20,10);
    //////////////////////////////////////
  }
  //////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////
  public void exit_gui(){
    fill(0);
    if((mouseX > 10) && (mouseX < 20) && (mouseY > 10) && (mouseY < 20)){
      stroke(255,20,0);
      strokeWeight(2);
      ellipse(15,15,12,12);
      line(12,12,18,18);
      line(18,12,12,18);
    }
    else{
      stroke(255);
      strokeWeight(1);
      ellipse(15,15,10,10);
    }
    strokeWeight(1);
  }
}

class History{
  String[] Metar = new String [1000];
  boolean rectxt = true;
  int read = 0;
  float interval = 0.00f;
  int num = 0;
  ///////////////////////////////////////////////////
  History(){
    Metar = loadStrings("history.txt");
    println("I load History File");
  }
  ///////////////////////////////////////////////////////
  public void draw(String name){
    /// Function to record Metar History Data Load into Txt
    /*if(num<2000){
     println("I try to wrtite history");
     if(rectxt == true){
     println("i write history " + num);
     num++;
     Metar[num] = name;
     saveStrings("/data/history.txt", Metar);
     }
     }
     else{
     println("I FINISH HISTORY WRITE DATA");
     }
     */
  }
  //////////////////////////////////////////////////////
  public void read(){
    interval += 0.1f;
    if(interval > 5){
      interval = 0;
      println("read history"+read+"  :  "+PApplet.parseInt(Metar[read]));
      statut = "> No NetWork : History Mode";
      read++;
      if(read>1000)read = 1;
      gui.couleur = color(0,0,0);
      metar[PApplet.parseInt(Metar[read])].refreshData();
    }
  }
}

class Metar{
  String myName;
  int myNum;
  String[] data;
  String[] windData = new String [4]; // [0] = Wind Orientation in \u00b0// [1] = Wind Speed in Kt // [2] = Wind Fluctuation in Kt;
  ////////////////////////
  String[] lat_long = new String [2];  // [0] = Latitude = PosY  // [1] = Longitude = PosY; 
  String[] myUTC = new String [5]; // [0] = Year  // [1] = Month  // [2] = Day  // [3] Hours  // [4] = Minutes ;
  String txtName = "";
  float posX,posY;
  int couleur = color(255,0,0);
  boolean anim = false;
  boolean refreshi = false;
  boolean asking = false;
  float taille = 0;
  int strokeCercle = 2;
  ////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////
  //////////////////////////////////////////INITIALISATION DE LA CLASS///////////////////////////////////////////////////////
  Metar(String[] info, String name, int num){
    data = info;
    myNum = num;
    myName = name;
    /////////////////////////////////////////////////////////////
    try{
      coordonnes();
      myName();
      ///////////////
      posX *= PApplet.parseFloat(lat_long[1]);
      posY *= PApplet.parseFloat(lat_long[0]);
      draw();
      //println(num+"is load "+name);
    }
    catch(Exception x){
      //dataFailded(myName);
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  public void draw(){
    try{
      noStroke();
      stroke(couleur);
      fill(couleur);
      rect((width/2)+(posX*facteurTaille)+depMapX,(height/2)+(posY*facteurTaille)-50+depMapY,1,1);
      //////////////
      if(anim == true){
        stroke(couleur,255-(taille));
        strokeWeight(strokeCercle);
        noFill();
        ellipse((width/2)+(posX*facteurTaille)+depMapX,(height/2)+(posY*facteurTaille)-50+depMapY,taille,taille);
        strokeWeight(1);
        /////////////////////////////////
        taille += 1;
        if(taille>250){
          taille = 0;
          anim = false;
        }
      }
      //////////////////////
      if((mouseX > ((width/2)+(posX*facteurTaille)-2+depMapX)) && (mouseX < ((width/2)+(posX*facteurTaille)+2+depMapX)) && (mouseY > ((height/2)+(posY*facteurTaille)-50-2+depMapY)) && (mouseY < ((height/2)+(posY*facteurTaille)-50+2+depMapY))){
        fill(255);
        textFont(fontC, 12);
        if(refreshi){
          anim = true;
          for(int i = 0; i<data.length-2; i++){
            text(data[i],(width/2)+(posX*facteurTaille)+depMapX,(height/2)+(posY*facteurTaille)-50+depMapY+(12*i));
          }
        }
        else{
          if(data != null)
            text(data[0],(width/2)+(posX*facteurTaille)+depMapX,(height/2)+(posY*facteurTaille)-50+depMapY);
        }
        /////////////////////////
        if (mousePressed){
          if(asking == false){
            if(nbrequest < maxrequest){
              couleur = color (0,200,50);
              strokeCercle = 3;
              if(nbrequest == 0){
                requestList[nbrequest] = str(myNum);
                udp.send(str(myNum), "localhost", 7000);
                nbrequest++;
              }
              else{
                requestList[nbrequest] = str(myNum);
                nbrequest++;
              }
              asking = true;
              //println("NetWork List Request for "+myNum);
              statut = "> NetWork Request for "+(myNum)+" = "+myName;
              gui.time = 0;
            }
          }
        }
      }
    }    
    catch(Exception x){
      println("Exception Draw : "+myName+" : " + x);
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  public void refreshData(){
    try{
      myName();
      ///////////////////////
      //http://www.weather.gov/xml/current_obs/Name.xml
      data = loadStrings("metar/"+myName+".txt");
      //////////////////////
      info = data;
      windDataFunction();
      curentWind = PApplet.parseInt(windData[1]);
      ////////////////////
      couleur = color(255);
      anim = true;
      refreshi = true;
      ///////////////////
      orientation = PApplet.parseInt (windData[0]);
      vitesse = PApplet.parseInt (windData[1]);
      //for(int i=0;i<nblife2;i++){
      //life2[i].orientation = int (windData[0]);
      //life2[i].vitesse = int (windData[1]);
      //}
      /////////////////////////////////
      if(gui.mode){
        for(int i=14 ; i > 0 ; i--){
          fan[i].power = fan[i-1].power;
          fan[i].name = fan[i-1].name;
        }
        fan[0].power = curentWind*PApplet.parseInt(love);
        fan[0].name = txtName;
      }
      else{
        fan[refeshFanStation].name = txtName;
        fan[refeshFanStation].power = curentWind*PApplet.parseInt(love);
        refeshFanStation++;
        if(refeshFanStation == 15) refeshFanStation = 0;
      }
      /////////////////////////////////////
      if(asking){
        statut = ("> Network Refreshed Station   code : "+myNum+" or "+myName);
        strokeCercle = 5;
        couleur = color (0,255,40);
        gui.time = 0;
        for(int i = 0; i < nbrequest+1; i++){
          if(requestList[i].equals(str(myNum))){
            for(int t = i; t < nbrequest+1; t++){
              requestList[t] = requestList[t+1];
            }
            nbrequest--;
          }
          if(requestList[i] == null){
            break;
          }
        }
      }
    }
    catch(Exception x){
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  public void windDataFunction(){
    if(data[2].charAt(0) == 'W'){
      String tempDataLine = data[(data.length)-2];
      String tempData [] = split(tempDataLine);
      String temp_windData = tempData[3];
      ///////////////// exeption dans la chaine d'info.... c bien chiant.... !!!
      if((tempData[3].equals("AUTO") == true) || (tempData[3].equals("COR") == true) || (tempData[3].equals("RTD") == true)) {
        temp_windData = tempData[4];
      }
      ////////////////////////////////////////////////////////
      ///////////////////////////////////////////////////////
      ////////// Split DataWind into [] ////////////////////
      if(temp_windData.length() > 9){
        /// Fluctuation in Data
        windData[0] = ""+temp_windData.charAt(0);
        windData[0] += temp_windData.charAt(1);
        windData[0] += temp_windData.charAt(2);
        //
        windData[1] = ""+temp_windData.charAt(3);
        windData[1] += temp_windData.charAt(4);
        //
        windData[2] = ""+temp_windData.charAt(6);
        windData[2] += temp_windData.charAt(7);
      }
      else if(temp_windData.charAt(0) == 'V'){
        /// Variable at 1 MPH (1 KT):0
        windData[0] = "0";
        windData[1] = ""+temp_windData.charAt(3);
        windData[1] += temp_windData.charAt(4);
        windData[2] = "0";
      }
      else{
        /// Normal Data
        windData[0] = ""+temp_windData.charAt(0);
        windData[0] += temp_windData.charAt(1);
        windData[0] += temp_windData.charAt(2);
        //
        windData[1] = ""+temp_windData.charAt(3);
        windData[1] += temp_windData.charAt(4);
        //
        windData[2] = "0";
      }
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  public void myName(){
    txtName = "";
    for(int i=0; i<data[0].length()-1; i++){
      char lettre = data[0].charAt(i);
      if(lettre == '(')break;
      txtName += lettre;
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  public void coordonnes(){
    ////////////////////////////Analyse de la Latitude & Longitude////////////////////////////////
    String tempPosition = data[0];
    lat_long[0] = "";
    lat_long[1] = "";
    int nbtiret = 0;
    int step = 0;
    /////////////////////////////////////////////////////////////////////////
    for(int c=0; c<tempPosition.length(); c++){
      char lettre = tempPosition.charAt(c);
      if(lettre == ')'){
        for(int i=c+2; i<tempPosition.length(); i++){
          lettre = tempPosition.charAt(i);
          /////////////////////////////////////////////////
          if (step < 2){
            if(lettre == '-'){
              if(nbtiret == 0){
                lat_long[step] += ".";
                i++;
                nbtiret++;
              }
              else if (nbtiret > 0){
                lat_long[step] += "";
                nbtiret++;
                i++;
              }
            }
            /////////////////////////////////////////////////
            if(step == 0){
              lettre = tempPosition.charAt(i);
              if(lettre == 'N'){
                posY = -1;
                step++;
                i+=2;
                nbtiret = 0;
              }
              else if(lettre == 'S'){
                posY = 1;
                step++;
                i+=2;
                nbtiret = 0;
              }
              else {
                lat_long[0] += lettre;
              }
            }
            ///////////////////////////////////////////////
            if(step == 1){
              lettre = tempPosition.charAt(i);
              if(lettre == 'E'){
                posX = 1;
                step++;
                i++;
              }
              else if(lettre == 'W'){
                posX = -1;
                step++;
                i++;
              }
              else {
                lat_long[1] += lettre;
              }
            }
            ////////////////////////////////////////////////
          }
        }
      }
    }
  }
}

class UDP_Conector{
  UDP_Conector(){
  }
  public void alive(){
    if(count==500){
      gui.couleur = color(200,0,50);
      if(auto)
        udp.send( "alive?", "localhost", 7000 );
    }
    if(count<500){
      gui.couleur = color(255);
    }
  }
  ///////////////////////////////////////////////////////////////////////////////
  public void receive( byte[] data, String ip, int port ) {
    String message = new String( data );
    println( "receive: "+message);
    gui.couleur = color(0,200,50);
    ////////
    if(message.equals("alive!")){
      gui.couleur = color(255);
      count = 0;
    }
    else{
      station = message;
      metar[PApplet.parseInt(station)].refreshData();
      //history.draw(station);
      count = 0;
      if(nbrequest>0){
        udp.send(requestList[1], "localhost", 7000);
      }
      else if(auto){
        int i = PApplet.parseInt(random(metarList.length));
        udp.send(str(i), "localhost", 7000);
      }
    }
  }
  /////////////////////////////////////////////////////////////////////////
}
}