//////////////////////////////////////
//           Wind Earth             //
//                                  //
//        by Pascal Chirol,         //
//  www.pascalchirol.easydesign.fr  //
//////////////////////////////////////
import processing.opengl.*;
import hypermedia.net.*;
//import moviemaker.*;
import processing.serial.*;
/////////////////////////////////////////////////////////////////////////////////////
boolean serialOn = false;
Serial port;
UDP udp;
UDP_Conector conector;
GUI gui;
//MovieMaker mm;
History history;
///////////////////////////////////
String[] metarList;
int nbMetar = 3978;
String[] dataFaild = new String [200];
int numFailed = 0;
Metar[]metar = new Metar[nbMetar];
int nblife = 0;
int nblife2 = 0;
int nblife3 = 0;
Draws[]life = new Draws[20];
Draws[]life2 = new Draws[20];
Draws[]life3 = new Draws[20];
//////
String request = "";
int nbrequest = 0;
int maxrequest = 200;
String [] requestList = new String [maxrequest];
String statut = "";
int countKey = 0;
boolean winddraws = false;
boolean waitingForTheSun = false;
boolean auto = true;
float facteurTaille = 3;
float love = 1;
int curentWind = 0;
int count = 0;
int refeshFanStation = 0;
String station = "";
String[] info;
boolean option = true;
boolean fan_option = true;
int nbFan = 15;
Fan[]fan = new Fan[nbFan];
String nameSerial;
float vitesse,orientation;
///////////////
float depMapX = 0;
float depMapY = 0;
//////////////
PFont fontL;
PFont fontLB;
PFont fontC;
//////////////
int nbloader = 0;
boolean isLoading = true;
/////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
///////////////////////////////////////
public static void main( String args[] ) {
  PApplet.main( new String[] { 
    "--present", "WindEarth_GUI"                        } 
  );
} 

//////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
void setup(){
  //////////
  size(screen.width,screen.height,OPENGL);
  facteurTaille = ((screen.width)/1000)*3;
  //frameRate(200);
  smooth();
  background(0);
  //////////////////////////////
  conector = new UDP_Conector();
  history = new History();
  gui = new GUI();
  udp = new UDP(this, 6000);
  udp.log( true );
  udp.listen(true);
  port = new Serial(this, Serial.list()[0], 19200);
  println(Serial.list());
  nameSerial = (Serial.list()[0]);
  //mm = new MovieMaker(this,width,height,"movie.mov", MovieMaker.CINEPAK, MovieMaker.HIGH,10);
  fontL = loadFont("LevenimMT-48.vlw");
  fontLB = loadFont("LevenimMTBold-48.vlw");
  fontC = loadFont("CourierNewPS-BoldMT-48.vlw");
  ////////////////////////////
  ///////////////////
  metarList = loadStrings("True_Metar.txt");
  ///////////////////
  if(isLoading == false){
    println("Beginning to Create Object Class && reading METAR Data into class");
    for (int i = 0; i < nbMetar ; i++){
      try{
        String[] data;
        data = loadStrings("metar/"+metarList[i]+".txt");//PC
        //data = loadStrings("/metar/"+metarList[i]+".txt");//MAC
        metar[i] = new Metar(data, metarList[i],i);
      }
      catch(Exception x){
        println(""+x);
      }
    }
    udp.send("alive?", "localhost", 7000);
    int i = int(random(metarList.length));
    udp.send(str(i), "localhost", 7000);
  }
  ///////////////////////////////
  for(int i=0 ; i<nbFan ; i++){
    fan[i] = new Fan(i);
  }
}
/////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
void draw(){
  background(0);
  /////////////////////////
  if(isLoading == true){
    count+=10;
    //////// Loading Animation....
    try{
      if (nbloader < nbMetar){
        String[] data;
        data = loadStrings("metar/"+metarList[nbloader]+".txt");//PC
        //data = loadStrings("/metar/"+metarList[nbloader]+".txt");//MAC
        metar[nbloader] = new Metar(data, metarList[nbloader],nbloader);
        nbloader++;
      }
      else{
        udp.send( "alive?", "localhost", 7000 );
        int i = int(random(metarList.length));
        udp.send(str(i), "localhost", 7000);
        count = 0;
        isLoading = false;
      }
      ///////////////////////////
      textFont(fontLB, 30);
      fill(255);
      text("Wind Earth",gui.posX,gui.posY);
      textFont(fontLB, 12);
      fill(count);
      text("Please Wait :",gui.posX,gui.posY+20);
      fill(255);
      text("Loading Meteorological Station  : "+nbloader+" / "+nbMetar,gui.posX+80,gui.posY+20);
      if(count>255)count=0;
      ///////////////////
      for (int i = 0; i < nbloader ; i++){
        metar[i].draw();
      }
    }    
    catch(Exception x){
      println(""+x);
    }
  }
  /////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////
  if(isLoading == false){
    count++;
    mouseDep();
    ////////////////////////
    for (int i = 0; i < nbMetar ; i++){
      metar[i].draw();
    }
    try{
      gui.serialColor = color (255);
      //////////////////////////////////////
      for(int i=0 ; i<nbFan ; i++){
        fan[i].serialSend();
      }
      gui.draw();
      if(winddraws){
        for(int i=0;i<nblife;i++){
          life[i].draw();
        }
        for(int i=0;i<nblife2;i++){
          life2[i].draw();
        }
        for(int i=0;i<nblife3;i++){
          life3[i].draw();
        }
      }
      /////////////////////////////////
      //loadPixels();
      //mm.addFrame(pixels,width,height);
      //println("I RecVideo");
    }  
    catch(Exception x){
    }
    conector.alive();
  }
  ///////////////////
}
///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////
void receive( byte[] data, String ip, int port ){
  conector.receive(data,ip,port);
}
//////////////////////////////////////////////////////////////////////////////
public void keyPressed() {
  ///////////////////////////////////////////////////////////
  gui.time = 0;
  statut = "> METAR Code : CAPS letters or Numbers are need";
  if(countKey == 0){
    request = "";
  }
  //////////////////////////////////////////////////////////
  if(keyCode == 27){
    udp.send("exit", "localhost", 7000);
  }
  if(keyCode == 32){
    statut = "> Up/Down = Zoom  ;  Space = Reset";
    facteurTaille = 3;
    depMapX = 0;
    depMapY = 0;
  }
  if(keyCode == UP){
    statut = "> Up/Down = Zoom  ;  Space = Reset";
    if(facteurTaille < 100){
      facteurTaille += 0.1;
    }
  }
  if(keyCode == DOWN){ 
    statut = "> Up/Down = Zoom  ;  Space = Reset";
    if(facteurTaille > 0.1){
      facteurTaille -= 0.1;
    }
  }
  if(facteurTaille < 3){
    depMapX = 0;
    depMapY = 0;
  }
  if(keyCode == RIGHT){
    statut = "> Up/Down = Zoom  ;  Space = Reset; ";
    if(facteurTaille > 3) depMapX -= facteurTaille;
  }
  if(keyCode == LEFT){
    statut = "> Up/Down = Zoom  ;  Space = Reset; ";
    if(facteurTaille > 3) depMapX += facteurTaille;
  }
  if((keyCode == 8) || (keyCode == 127)){
    countKey=0;
    request = "";
  }
  if(int(key) > 64 && int(key) < 91){
    countKey++;
    request += key;
  }
  if(int(key) > 47 && int(key) < 58){
    countKey++;
    request += key;
  }
  ////////////////////////////////////////////////////////////////////////////
  if(countKey > 3){
    statut = "> "+nbMetar+" is false code or number > ";
    int temp = int(request);
    if((temp != 0) && (temp < 3978)){
      udp.send(request, "localhost", 7000 );
      println("NetWork Request for "+temp);
      statut = "> NetWork Request for  : "+(temp)+" = "+metar[int(temp)].myName;
    }
    else{
      for(int i=0; i<metarList.length;i++){
        if(request.equals(metarList[i])){
          udp.send(str(i), "localhost", 7000 );
          println("NetWork Request for : "+request);
          statut = "> NetWork Request for  : "+(request)+" = "+i;
        }
      }
    }
    countKey = 0;
    ///////////////////////////////////////////////////
  }
}
///////////////////////////////////////////////////////////////////////////////
public void dataFailded(String name){
  numFailed++;
  dataFaild[numFailed] = name;
  saveStrings("data/dataFaild.txt", dataFaild);
}
///////////////////////////////////////////////////////
void mouseDep(){
  if(facteurTaille >3){
    if(mouseX<width/10)depMapX += (facteurTaille/constrain(mouseX,10,200))*10;
    if(mouseX>width-(width/10))depMapX -= (facteurTaille/constrain(width-mouseX,10,200))*10;
    if(mouseY<height/10)depMapY += (facteurTaille/constrain(mouseY,10,200))*10;
    if(mouseY>height-(height/20))depMapY -= (facteurTaille/constrain(height-mouseY,10,200))*10;
  }
}
///////////////////////////////////////////////////////////
void mousePressed() {
  if((mouseX > 10) && (mouseX < 20) && (mouseY > 10) && (mouseY < 20)){
    udp.send("exit", "localhost", 7000);
    exit();
  }
  if((mouseX > gui.posX) && (mouseX < gui.posX+170) && (mouseY > gui.posY) && (mouseY < gui.posY+25)) {
    auto =! auto;
    if(auto){
      int i = int(random(metarList.length));
      udp.send(str(i), "localhost", 7000);
    }
  }
  if((mouseX > gui.posX+185) && (mouseX < gui.posX+280) && (mouseY > gui.posY+5) && (mouseY < gui.posY+25)) {
    winddraws =! winddraws;
  }
  if((mouseX > gui.posX+305) && (mouseX < gui.posX+405) && (mouseY > gui.posY) && (mouseY < gui.posY+25)) {
    //gui.fan_gui =! gui.fan_gui;
  }
  if(winddraws){
    if((mouseX > gui.posX+185) && (mouseX < gui.posX+195) && (mouseY > gui.posY-5) && (mouseY < gui.posY+5)) {
      if(mouseButton == RIGHT){
        for(int i = 0;i<nblife;i++){
          life[i] = null;
        }
        nblife=0;
      }
      if(mouseButton == LEFT){
        if(nblife<20){
          life[nblife] = new Draws(0);
          nblife++;
        }
      }
    }
    /////////////////////////////
    if((mouseX > gui.posX+185) && (mouseX < gui.posX+195) && (mouseY > gui.posY-20) && (mouseY < gui.posY-10)) {
      if(mouseButton == RIGHT){
        for(int i = 0;i<nblife2;i++){
          life2[i] = null;
        }
        nblife2=0;
      }
      if(mouseButton == LEFT){
        if(nblife2<20){
          life2[nblife2] = new Draws(1);
          nblife2++;
        }
      }
    }
    /////////////////////////////
    if((mouseX > gui.posX+185) && (mouseX < gui.posX+195) && (mouseY > gui.posY-35) && (mouseY < gui.posY-25)) {
      if(mouseButton == RIGHT){
        for(int i = 0;i<nblife3;i++){
          life3[i] = null;
        }
        nblife3=0;
      }
      if(mouseButton == LEFT){
        if(nblife3<20){
          life3[nblife3] = new Draws(2);
          nblife3++;
        }
      }
    }
  }
  ///////////////////////
  if((mouseX > width-225) && (mouseX < width-225+200) && (mouseY > fan[0].y+55) && (mouseY < fan[0].y+85)) {
    love = float((mouseX-(width-225))/20);
  }
  if(gui.fan_gui){
    if((mouseX > fan[0].x) && (mouseX < fan[0].x+50) && (mouseY > fan[0].y+55) && (mouseY < fan[0].y+85)) {
      gui.mode =! gui.mode;
      if(gui.mode){
        gui.fanModeColor = color(255);
      }
      else{
        gui.fanModeColor = color(0);  
      }
    }
    if((mouseX > fan[0].x+105) && (mouseX < fan[0].x+155) && (mouseY > fan[0].y+55) && (mouseY < fan[0].y+85)) {
      serialOn =! serialOn;
      println(Serial.list());
      if(serialOn == true){
        for(int i=0 ; i<nbFan ; i++){
          fan[i].tempPower = 0;
        }
      }
      if(serialOn == false){
        port.write(200); // reset value external PIC
      }
    }
  }
  ///////////////////
}
